/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/

#ifndef CB_PRESENCE_H_INCLUDED
#define CB_PRESENCE_H_INCLUDED 1

#include "symbian_tree.h"
#include "list.h"
#include "jabberdata.h"
#include "csd_presence.h"
#include "timeout.h"
#include "cbbsession.h"


class MPresenceListener {
public:
	virtual void PresenceChangedL(TInt ContactId, CBBPresence* Info) = 0;
	virtual void Notify(const TDesC & aMessage) = 0;
};

class CPresenceHolder : public CBase, public MBBObserver, public MContextBase  {
public:
	IMPORT_C static CPresenceHolder* NewL(CJabberData& JabberData);
	IMPORT_C ~CPresenceHolder();

	IMPORT_C void AddListener(MPresenceListener* Listener);
	IMPORT_C const CBBPresence* const GetPresence(TInt ContactId) const;

	IMPORT_C void CancelRequest();
	//IMPORT_C void NewPresence(const TDesC& Nick, const TDesC& Info, const TTime& send_timestamp);
	IMPORT_C CBBPresence* GetPresence(TInt ContactId);

private:

	virtual void NewValueL(TUint aId, const TTupleName& aName, const TDesC& aSubName, 
		const TComponentName& aComponentName, const MBBData* aData);
	virtual void DeletedL(const TTupleName& aName, const TDesC& aSubName);
private:
	CPresenceHolder(CJabberData& JabberData);
	void ConstructL();

	static void CBBPresenceDeletor(void* p);

	CJabberData&			iJabberData;
	CGenericIntMap*			iPresenceData;
	CList<MPresenceListener*>*	iListeners;

private:
	TTime				iSendTimeStamp;
	static const TInt KDefaultBufferSize;

	class CBBSubSession*		iBBSession;
};

#endif
