#ifndef CONTEXT_BBL_PROTOCOL_H_INCLUDED
#define CONTEXT_BBL_PROTOCOL_H_INCLUDED 1

#include "enginenotifier.h"
#include "app_context.h"
#include "checkedactive.h"
#include "csd_event.h"
#include "socketslistener.h"
#include "status_notif.h"

class MBBLocalNotifier {
public:
	virtual void Acked(TUint id) = 0;
	virtual void IncomingTuple(const CBBTuple* aTuple) = 0;
	virtual void Error(TInt aError, TInt aOrigError, const TDesC& aDescr) = 0;
	virtual void ReadyToWrite(TBool aReady) = 0;
	virtual void Disconnected() = 0;
};

class MBBLocalProtocolOwner {
public:
	virtual void ProtocolDeleted(class CBBLocalProtocol* aProtocol) = 0;
};

class CBBLocalProtocol : public CBase, public MSocketAcceptor {
public:
	IMPORT_C static CBBLocalProtocol* NewL(MApp_context& aContext, MBBLocalProtocolOwner& aOwner);
	CBBLocalProtocol();

	virtual void AddObserverL(MBBLocalNotifier* aObserver) = 0;

	virtual void Disconnect(TBool closeConnection) = 0;

	virtual void WriteL(const TDesC16& aData) = 0;

	virtual void SendXMLStreamHeaderL() = 0;

	virtual void SendDisconnectionL() = 0;
	virtual void SendXmlPacketL(const TDesC& aPacket) = 0; // data has to live until acked

	virtual void Read() = 0;
	virtual TBool Connected() const = 0;
};

#endif
