#include "mcc.h"

struct TMccItem {
	TInt		iMcc;
	const TLitC16<1>::__TText*	iCountryName;
};

/*
 * from the wikipedia
 */

static const TMccItem KMccItems[]= {
	{ 202,  L"Greece" },
	{ 204,  L"Netherlands" },
	{ 206,  L"Belgium" },
	{ 208,  L"France" },
	{ 212,  L"Monaco" },
	{ 213,  L"Andorra" },
	{ 214,  L"Spain" },
	{ 216,  L"Hungary" },
	{ 218,  L"Bosnia and Herzegovina" },
	{ 219,  L"Croatia" },
	{ 220,  L"Serbia and Montenegro" },
	{ 222,  L"Italy" },
	{ 225,  L"Vatican City State" },
	{ 226,  L"Romania" },
	{ 228,  L"Switzerland" },
	{ 230,  L"Czech Republic" },
	{ 231,  L"Slovakia" },
	{ 232,  L"Austria" },
	{ 234,  L"United Kingdom" },
	{ 235,  L"United Kingdom" },
	{ 238,  L"Denmark" },
	{ 240,  L"Sweden" },
	{ 242,  L"Norway" },
	{ 244,  L"Finland" },
	{ 246,  L"Lithuania" },
	{ 247,  L"Latvia" },
	{ 248,  L"Estonia" },
	{ 250,  L"Russian Federation" },
	{ 255,  L"Ukraine" },
	{ 257,  L"Belarus" },
	{ 259,  L"Moldova" },
	{ 260,  L"Poland" },
	{ 262,  L"Germany" },
	{ 266,  L"Gibraltar" },
	{ 268,  L"Portugal" },
	{ 270,  L"Luxembourg" },
	{ 272,  L"Ireland" },
	{ 274,  L"Iceland" },
	{ 276,  L"Albania" },
	{ 278,  L"Malta" },
	{ 280,  L"Cyprus" },
	{ 282,  L"Georgia" },
	{ 283,  L"Armenia" },
	{ 284,  L"Bulgaria" },
	{ 286,  L"Turkey" },
	{ 288,  L"Faroe Islands" },
	{ 290,  L"Greenland" },
	{ 292,  L"San Marino" },
	{ 293,  L"Slovenia" },
	{ 294,  L"Macedonia" },
	{ 295,  L"Liechtenstein" },
	{ 302,  L"Canada" },
	{ 308,  L"Saint Pierre and Miquelon" },
	{ 310,  L"United States of America" },
	{ 311,  L"United States of America" },
	{ 312,  L"United States of America" },
	{ 313,  L"United States of America" },
	{ 314,  L"United States of America" },
	{ 315,  L"United States of America" },
	{ 316,  L"United States of America" },
	{ 330,  L"Puerto Rico" },
	{ 332,  L"United States Virgin Islands" },
	{ 334,  L"Mexico" },
	{ 338,  L"Jamaica" },
	{ 340,  L"Guadeloupe" },
	{ 340,  L"Martinique" },
	{ 342,  L"Barbados" },
	{ 344,  L"Antigua and Barbuda" },
	{ 346,  L"Cayman Islands" },
	{ 348,  L"British Virgin Islands" },
	{ 350,  L"Bermuda" },
	{ 352,  L"Grenada" },
	{ 354,  L"Montserrat" },
	{ 356,  L"Saint Kitts and Nevis" },
	{ 358,  L"Saint Lucia" },
	{ 360,  L"Saint Vincent and the Grenadines" },
	{ 362,  L"Netherlands Antilles" },
	{ 363,  L"Aruba" },
	{ 364,  L"Bahamas" },
	{ 365,  L"Anguilla" },
	{ 366,  L"Dominica" },
	{ 368,  L"Cuba" },
	{ 370,  L"Dominican Republic" },
	{ 372,  L"Haiti" },
	{ 374,  L"Trinidad and Tobago" },
	{ 376,  L"Turks and Caicos Islands" },
	{ 400,  L"Azerbaijani Republic" },
	{ 401,  L"Kazakhstan" },
	{ 402,  L"Bhutan" },
	{ 404,  L"India" },
	{ 410,  L"Pakistan" },
	{ 412,  L"Afghanistan" },
	{ 413,  L"Sri Lanka" },
	{ 414,  L"Myanmar" },
	{ 415,  L"Lebanon" },
	{ 416,  L"Jordan" },
	{ 417,  L"Syria" },
	{ 418,  L"Iraq" },
	{ 419,  L"Kuwait" },
	{ 420,  L"Saudi Arabia" },
	{ 421,  L"Yemen" },
	{ 422,  L"Oman" },
	{ 424,  L"United Arab Emirates" },
	{ 425,  L"Israel" },
	{ 426,  L"Bahrain" },
	{ 427,  L"Qatar" },
	{ 428,  L"Mongolia" },
	{ 429,  L"Nepal" },
	{ 430,  L"United Arab Emirates (Abu Dhabi)" },
	{ 431,  L"United Arab Emirates (Dubai)" },
	{ 432,  L"Iran" },
	{ 434,  L"Uzbekistan" },
	{ 436,  L"Tajikistan" },
	{ 437,  L"Kyrgyz Republic" },
	{ 438,  L"Turkmenistan" },
	{ 440,  L"Japan" },
	{ 441,  L"Japan" },
	{ 450,  L"South Korea" },
	{ 452,  L"Viet Nam" },
	{ 454,  L"Hong Kong, China" },
	{ 455,  L"Macao, China" },
	{ 456,  L"Cambodia" },
	{ 457,  L"Laos" },
	{ 460,  L"China" },
	{ 461,  L"China" },
	{ 466,  L"Taiwan" },
	{ 467,  L"North Korea" },
	{ 470,  L"Bangladesh" },
	{ 472,  L"Maldives" },
	{ 502,  L"Malaysia" },
	{ 505,  L"Australia" },
	{ 510,  L"Indonesia" },
	{ 514,  L"East Timor" },
	{ 515,  L"Philippines" },
	{ 520,  L"Thailand" },
	{ 525,  L"Singapore" },
	{ 528,  L"Brunei Darussalam" },
	{ 530,  L"New Zealand" },
	{ 534,  L"Northern Mariana Islands" },
	{ 535,  L"Guam" },
	{ 536,  L"Nauru" },
	{ 537,  L"Papua New Guinea" },
	{ 539,  L"Tonga" },
	{ 540,  L"Solomon Islands" },
	{ 541,  L"Vanuatu" },
	{ 542,  L"Fiji" },
	{ 543,  L"Wallis and Futuna" },
	{ 544,  L"American Samoa" },
	{ 545,  L"Kiribati" },
	{ 546,  L"New Caledonia" },
	{ 547,  L"French Polynesia" },
	{ 548,  L"Cook Islands" },
	{ 549,  L"Samoa" },
	{ 550,  L"Micronesia" },
	{ 551,  L"Marshall Islands" },
	{ 552,  L"Palau" },
	{ 602,  L"Egypt" },
	{ 603,  L"Algeria" },
	{ 604,  L"Morocco" },
	{ 605,  L"Tunisia" },
	{ 606,  L"Libya" },
	{ 607,  L"Gambia" },
	{ 608,  L"Senegal" },
	{ 609,  L"Mauritania" },
	{ 610,  L"Mali" },
	{ 611,  L"Guinea" },
	{ 612,  L"Cte d'Ivoire" },
	{ 613,  L"Burkina Faso" },
	{ 614,  L"Niger" },
	{ 615,  L"Togolese Republic" },
	{ 616,  L"Benin" },
	{ 617,  L"Mauritius" },
	{ 618,  L"Liberia" },
	{ 619,  L"Sierra Leone" },
	{ 620,  L"Ghana" },
	{ 621,  L"Nigeria" },
	{ 622,  L"Chad" },
	{ 623,  L"Central African Republic" },
	{ 624,  L"Cameroon" },
	{ 625,  L"Cape Verde" },
	{ 626,  L"So Tom and Prncipe" },
	{ 627,  L"Equatorial Guinea" },
	{ 628,  L"Gabonese Republic" },
	{ 629,  L"Republic of the Congo" },
	{ 630,  L"Democratic Republic of the Congo" },
	{ 631,  L"Angola" },
	{ 632,  L"Guinea-Bissau" },
	{ 633,  L"Seychelles" },
	{ 634,  L"Sudan" },
	{ 635,  L"Rwandese Republic" },
	{ 636,  L"Ethiopia" },
	{ 637,  L"Somalia" },
	{ 638,  L"Djibouti" },
	{ 639,  L"Kenya" },
	{ 640,  L"Tanzania" },
	{ 641,  L"Uganda" },
	{ 642,  L"Burundi" },
	{ 643,  L"Mozambique" },
	{ 645,  L"Zambia" },
	{ 646,  L"Madagascar" },
	{ 647,  L"Runion" },
	{ 648,  L"Zimbabwe" },
	{ 649,  L"Namibia" },
	{ 650,  L"Malawi" },
	{ 651,  L"Lesotho" },
	{ 652,  L"Botswana" },
	{ 653,  L"Swaziland" },
	{ 654,  L"Comoros" },
	{ 655,  L"South Africa" },
	{ 657,  L"Eritrea" },
	{ 702,  L"Belize" },
	{ 704,  L"Guatemala" },
	{ 706,  L"El Salvador" },
	{ 708,  L"Honduras" },
	{ 710,  L"Nicaragua" },
	{ 712,  L"Costa Rica" },
	{ 714,  L"Panama" },
	{ 716,  L"Peru" },
	{ 722,  L"Argentine Republic" },
	{ 724,  L"Brazil" },
	{ 730,  L"Chile" },
	{ 732,  L"Colombia" },
	{ 734,  L"Venezuela" },
	{ 736,  L"Bolivia" },
	{ 738,  L"Guyana" },
	{ 740,  L"Ecuador" },
	{ 742,  L"French Guiana" },
	{ 744,  L"Paraguay" },
	{ 746,  L"Suriname" },
	{ 748,  L"Urugua" }
};

#define MCC_COUNT 231
#define OFFSET_OF(type, field) ((int)&( ((type *)0)->field) )

class TMccKey : public TKey {
public:
	TMccKey() : TKey(OFFSET_OF(TMccItem, iMcc), ECmpTInt) { }
private:
	TAny* At(TInt anIndex) const {
		const char * item;
		if (anIndex==KIndexPtr) {
			item=(const char *)iPtr;
		} else {
			item=(const char *)&(KMccItems[anIndex]);
		}
		return (void*)(item+iKeyOffset);
	}
};

EXPORT_C void GetCountryName(TInt aMcc, TDes& aInto)
{
	TMccItem i= { aMcc, L"" };
	TMccKey k;
	k.SetPtr(&i);
	TInt pos;
	if ( User::BinarySearch(MCC_COUNT, k, pos)==0 ) {
		aInto = (TText16*)KMccItems[pos].iCountryName;
	} else {
		aInto.Zero();
	}
}
